// ConformSelDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ConformSel.h"
#include "ConformSelDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConformSelDlg dialog

CConformSelDlg::CConformSelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConformSelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConformSelDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CConformSelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConformSelDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConformSelDlg, CDialog)
	//{{AFX_MSG_MAP(CConformSelDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(BTN_CREATESEL, OnCreateSel)
	ON_BN_CLICKED(BTN_RELEASESEL, OnReleaseSel)
	ON_BN_CLICKED(BTN_TEST, OnTest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConformSelDlg message handlers

BOOL CConformSelDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CConformSelDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CConformSelDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CConformSelDlg::OnOK() 
{
	// TODO: Add extra validation here
	
	CDialog::OnOK();
}

void CConformSelDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

#include "..\sys\Prism.h"
#include "DrvFunc.h"

HANDLE	G_hDrv = NULL;
#define DRIVE_NAME	"ConformSel"

unsigned short G_ConformSel = 0;
void CConformSelDlg::OnCreateSel() 
{
	CONFORMING_INFO conformInfo;

	if(G_hDrv == NULL) 
	{
		G_hDrv = MakeDrvSimpleStart(NULL, DRIVE_NAME);
		if(G_hDrv == NULL) return;
	}
    

	MakeDrvIoControl (G_hDrv, IOCTL_CREATE_CONFORMING_CODE, &conformInfo, sizeof(CONFORMING_INFO),
					&conformInfo, sizeof(CONFORMING_INFO));

	G_ConformSel = conformInfo.ConformingSel;

}

void CConformSelDlg::OnReleaseSel() 
{
	CONFORMING_INFO conformInfo;

	if(G_hDrv && G_ConformSel)
	{
		conformInfo.ConformingSel = G_ConformSel;
		MakeDrvIoControl (G_hDrv, IOCTL_RELEASE_CONFORMING_CODE, &conformInfo, sizeof(CONFORMING_INFO),
						&conformInfo, sizeof(CONFORMING_INFO));

		G_ConformSel = 0;
	}

}

BOOL CConformSelDlg::DestroyWindow() 
{
	if(G_hDrv)
	{
		MakeDrvStop(DRIVE_NAME, G_hDrv);
	}
	
	return CDialog::DestroyWindow();
}

static TEST_BODY()
{
	int nTest;

	nTest = 10;
}

static void _declspec(naked) TEST()
{
	TEST_BODY();
	__asm
	{
		retf
	}
}

void CConformSelDlg::OnTest() 
{
	short farcall[3];
	DWORD *p;

	p = (DWORD *)farcall;
	*p = (DWORD)TEST;
	farcall[2]=G_ConformSel; 
	__asm
	{
        call fword ptr [farcall]
	}
}
