//Sound.h
#ifndef _PRISM_H
#define _PRISM_H

#define NT_DEVICE_NAME	L"\\Device\\HookService"
#define DOS_DEVICE_NAME L"\\DosDevices\\HookService"
#define PRISM_DEVICE_TYPE 0x0000AA71

//
#define PRISM_IO(_code)		CTL_CODE(PRISM_DEVICE_TYPE, _code, METHOD_BUFFERED, FILE_ANY_ACCESS)

#define IOCTL_HOOK_CREATE_FILE			PRISM_IO(0x7)	//
#define IOCTL_UNHOOK_CREATE_FILE		PRISM_IO(0x8)	//


//DYNAMIC PLATFORM DEFINE
#define	WIN_VER_40	0x01	//001
#define	WIN_VER_2K	0x02	//010
#define	WIN_VER_XP	0x04	//100

extern ULONG	G_nWinMajorVersion; //initiaize -1
extern ULONG	G_nWinMinorVersion; //initiaize -1

#define	BEGINE_WIN_VER(x) \
	{	\
		if(G_nWinMajorVersion == -1) \
		{	\
			PsGetVersion(&G_nWinMajorVersion, &G_nWinMinorVersion, NULL, NULL);	\
			KdPrint(("OS Version %d(%d)\n", G_nWinMajorVersion, G_nWinMinorVersion));	\
			if(G_nWinMajorVersion == 4)	\
			{	G_nWinMajorVersion = WIN_VER_40; }	\
			else if(G_nWinMajorVersion == 5 && G_nWinMinorVersion == 0)	\
			{	G_nWinMajorVersion = WIN_VER_2K; }	\
			else if(G_nWinMajorVersion == 5 && G_nWinMinorVersion == 1)	\
			{	G_nWinMajorVersion = WIN_VER_XP; }	\
		} \
		if(G_nWinMajorVersion & ( x ))	\
		{
		
#define ELSE_WIN_VER()	 }else {
	
#define ELSE_IF_WIN_VER(x)	 }else if(G_nWinMajorVersion & ( x )) {

#define END_WIN_VER()	 } }



#endif
