//Sound.c
#include "ntddk.h"
#include "Prism.h"
#include "Intel80x86.h"

void IntIDT_Print();

VOID My_DriverEntry(IN PDRIVER_OBJECT DriverObject ,PDEVICE_OBJECT deviceObject)
{
}

VOID My_DriverUnload(IN PDRIVER_OBJECT DriverObject)
{
}

	
NTSTATUS My_IoControl(PFILE_OBJECT pFileObject, ULONG nIoCode, PCHAR pSystemBuffer, ULONG nInput, ULONG nOutput, ULONG *nReturnOut)
{
	if(nIoCode == IOCTL_PRINT_IDT)
	{
		IntIDT_Print();
	}	
	
	return STATUS_SUCCESS;
}

void IntIDT_Print()
{
    PIDT_ENTRY  aIdtEntry;
	ULONG	nIndex;
	ULONG	dwHandler;
    char 	szBuffIdtr[6];
    PIDTR 	pIDTR=(PIDTR)szBuffIdtr;
    
	//
    _asm sidt szBuffIdtr;
    aIdtEntry=(PIDT_ENTRY)pIDTR->Base;

	for(nIndex = 0; nIndex < 256; nIndex ++)
	{
	    dwHandler=((ULONG)aIdtEntry[nIndex].Offset_16_31<<16U)| 
	    			(aIdtEntry[nIndex].Offset_0_15);
		
		DbgPrint("[0x%X] Selector 0x%x, Offset : 0x%X , Type(0x%x), DPL(%d), Present(%d)\n", 
		nIndex,	aIdtEntry[nIndex].Selector, dwHandler, aIdtEntry[nIndex].Type,
		aIdtEntry[nIndex].DPL,aIdtEntry[nIndex].Present);		
	}	
}
